import java.util.*; import java.awt.*; import java.io.*; import java.awt.image.*;
import javax.swing.*;

/*
	Lib_Util.java 
	(c)1999-2003 SSC Development Team
	Function: Managing generally useful functions.
	Allowed Dependencies: None	
*/

public class Lib_Util 
{
public static Tileset ImportIntoTileset(String filename, Tileset b) {

	//TODO:Check if file exists and if it's the right kind of image!
	Tileset imported = new Tileset(filename);
	for(int i=0; i<imported.getLength(); i++) {
		b.addTile();
		b.setTile(b.getLength()-1,imported.getTile(i));
		}	
	
	return b;
	}
	
/* Converts Tile to SMF1 format */	
public static SMF_Tile1 Tile2SMF_Tile1(Tile t) {
	SMF_Tile1 smf = new SMF_Tile1();
	smf.nextTile = t.getNextTile();
	smf.rgbs = t.getRgbs();
	return smf;
	}	
	
/* Converts Tile from SMF1 format */
public static Tile SMF_Tile12Tile(SMF_Tile1 smf) {
	Tile t = new Tile();
	t.setRgbs(smf.rgbs);
	t.setNextTile(smf.nextTile);
	return t;
	}	
	
/* Converts Tileset to SMF1 format */	
public static SMF_Tileset1 Tileset2SMF_Tileset1(Tileset t) {
	
	SMF_Tileset1 smf = new SMF_Tileset1();
	smf.tiles = new Vector();
	
	smf.length = t.getLength();
	
	for(int i=0;i<t.getLength();i++) {
		smf.tiles.addElement(Tile2SMF_Tile1(t.getTile(i)));
		}	
	
	return smf;
	}
	
/* Converts Tileset from SMF1 format */
public static Tileset SMF_Tileset12Tileset(SMF_Tileset1 smf) {
	Tileset t = new Tileset();
	
	/* Adjust size of the Tile vector */
	if(smf.length>t.getLength()) {
		for(int i=t.getLength();i<smf.length;i++) {
			t.addTile();
			}
		}
	/*Move tiles to the new Tile vector */	
	for(int i=0;i<smf.length;i++) {
		t.setTile(i, SMF_Tile12Tile((SMF_Tile1) smf.tiles.elementAt(i)));
		}
	
	return t;
	}	
	
/* Converts Map to SMF1 Format*/	
public static SMF_WalkMap1 WalkMap2SMF_WalkMap1(WalkMap m) {
	SMF_WalkMap1 smf = new SMF_WalkMap1();
	smf.tileset = Tileset2SMF_Tileset1(m.getTileset());
	smf.tiles = m.getTiles();
	smf.width = m.getWidth();
	smf.height = m.getHeight();

	return smf;
	}

/* Converts Map from SMF1 Format*/	
public static WalkMap SMF_WalkMap12WalkMap(SMF_WalkMap1 smf) {
	WalkMap m = new WalkMap();
	m.setTileset(SMF_Tileset12Tileset(smf.tileset));
	m.resize(smf.width, smf.height);
	m.setTiles(smf.tiles);
	
	return m;
	}	
}