import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

/*
	Shiny_Sword.java
  	(c)1999-2002 SSC Development Team
	Functions: 
	-Initializing the game. Main program.
	Allowed Dependencies: Any
*/

class Shiny_Sword {
	
	public static void main(String args[]) {
		WalkMap cur_map = new WalkMap();
		
		System.out.println("Starting Shiny_Sword...");
		
		System.out.println("Initializing tiles.");
		
		System.out.println("Initializing map array.");

        try {	
        	// Deserialize from a file
        	File file = new File("start.smf"); //starting map is start.smf!
        	ObjectInputStream in = new ObjectInputStream(new FileInputStream(file));
        	// Deserialize the object
        	Object o = in.readObject();
        	cur_map = Lib_Util.SMF_WalkMap12WalkMap((SMF_WalkMap1) o);
        	in.close(); 
            Buffer.initializeTiles(cur_map);
            }  
        catch (ClassNotFoundException e) 
           { 
           System.out.println(e); 
           System.out.println("Start.smf seems to be corrupted or in an unrecognized format!"); 
           } 
        catch (IOException e) 
           { 
           System.out.println(e); 
           System.out.println("Start.smf refuses to load!"); 
           }
		
		System.out.println("Initializing sprites.");
		
		Buffer.addSprite(new Sprite("sprites/swordchar.gif"));
		Buffer.SX = 100;
		Buffer.SY = 100;
		Buffer.SF = 4;
		
		System.out.println("Launching interface. Happy playing!");
		
		MainFrame main = new MainFrame(cur_map); 
		main.setTitle("Shiny Sword");
		main.setSize(365, 265);
		main.setResizable(false);
		main.setVisible(true);
	}
}
