import java.awt.*; import java.awt.event.*; import javax.swing.*; import java.awt.image.*;

/*
	SmeeFrame.java
  	(c)1999-2002 SSC Development Team
	Functions: 
	-Managing the Map Editor GUI and input as a whole.
	Allowed Dependencies: SmeePanel.java
*/

public class SmeeFrame 	extends JFrame 
						implements 	ActionListener, KeyListener, 
									MouseListener, MouseMotionListener,	
									WindowFocusListener 
{
	Container c = getContentPane();	
		
	Timer timer;
	private JLabel label, curtile; 
    private JTextField prompt;
    private JScrollPane scroll; 
	private JScrollBar vert_scroll;
	private Image bg, save, load, tile, resize, newmap, uparrow, downarrow, to_png;
	private Image button1, button2, button3, b1A,b2A,b3A,b1B,b2B,b3B;
	private String mouseover = "";
    	
	SmeePanel screen; 
	//ButtonPanel buttons;
		
	public SmeeFrame(WalkMap cur_map)
	{
		this.setVisible(false);
		
		/*
		 * IMAGE PRELOAD
	 	 */
		bg = new ImageIcon("interface/Interface.gif").getImage();
		save = new ImageIcon("interface/Buttons/save_map_A.gif").getImage();
		load = new ImageIcon("interface/Buttons/open_map_A.gif").getImage();
		tile = new ImageIcon("interface/Buttons/tile_edit_A.gif").getImage();
		resize = new ImageIcon("interface/Buttons/map_size_A.gif").getImage();
		to_png = new ImageIcon("interface/Buttons/map_to_png_A.gif").getImage();

		newmap = new ImageIcon("interface/Buttons/new_map_A.gif").getImage();
		uparrow = new ImageIcon("interface/Scrollbar/up_A.gif").getImage();
		downarrow = new ImageIcon("interface/Scrollbar/down_A.gif").getImage();
		b1A = Lib_Image.getImage("interface/Layers/1A.gif");
		b1B = Lib_Image.getImage("interface/Layers/1B.gif");
		b2A = Lib_Image.getImage("interface/Layers/2A.gif");
		b2B = Lib_Image.getImage("interface/Layers/2B.gif");
		b3A = Lib_Image.getImage("interface/Layers/3A.gif");
		b3B = Lib_Image.getImage("interface/Layers/3B.gif");
		button1 = b1B;
		button2 = b2A;
		button3 = b3A;
		this.cur_map = cur_map;	
		
		//buttons = new ButtonPanel(this);
		Buffer.setCurMap(cur_map);
		Buffer.setCurLayer(0);
		screen = new SmeePanel(cur_map,0,0,360,240);
				
		timer = new Timer(25, this);
		//timer.setInitialDelay(3000);
		prompt = new JTextField("");

		screen.setBounds(19,23,360,240);
		prompt.setBounds(5,385,0,0);
		       
		c.setLayout(null);

		c.add(screen);
		c.add(prompt);
										
		prompt.addKeyListener(this);
        //buttons.addMouseListener(buttons);	
        //buttons.addMouseMotionListener(this);
        screen.addMouseListener(this);
        screen.addMouseMotionListener(this);	
        this.addWindowFocusListener(this);
        this.addMouseListener(this);
        this.addMouseMotionListener(this);
		
		
		
		this.setVisible(true);
		
		startAnimation();
	}	

	public synchronized void startAnimation() {
        timer.start();
    }


    public synchronized void stopAnimation() {
        timer.stop();
    }


	int x=0; //map x offset
    int y=0; //map y offset
    int anim_delay = 10; //Animation delay per frame
    int anim_iterator = 0;

	/*
	 * DRAWING ROUTINE
	 */

	WalkMap cur_map;
	int start;
	
	public void paint(Graphics f) {
		
		super.paint(f);	
		Graphics2D g = (Graphics2D) f;
		
		g.drawImage(bg,3,22,this);
		g.drawImage(resize,  36, 352, this);
		g.drawImage(save, 36, 324, this);
		g.drawImage(load, 64, 352, this);
		g.drawImage(tile, 64, 324, this);
		g.drawImage(newmap, 92, 324, this);
		g.drawImage(to_png, 92, 352, this);
		
		g.drawImage(button1, 7, 87, this); 
		g.drawImage(button2, 7, 112, this); 
		g.drawImage(button3, 7, 137, this);		
		
		g.drawImage(uparrow,502,45,this);
       	g.drawImage(downarrow,502,289,this);		
		
		g.drawString("CurTile = ",31,304);
		g.drawImage(cur_map.getTileset().getTileContents(Buffer.getCurTile()),83,294,95,306,0,0,23,23,new Color(0),this);
		
		int length = cur_map.getTileset().getLength();
			
		//drawing tileset
		g.setColor(new Color(0,0,0));
		g.fillRect(401, 46, 100, 250); 
        for(int i=start*4;i<(start*4+40);i++) {
        	g.drawImage(cur_map.getTileset().getTileContents(i),401+((i%4)*25),46+((i/4)*25)-(start*25),new Color(0),this); 
       	}  
       	
       	/*Mouseover part*/
    	f.setColor(new Color(208,236,124));
	    f.fillRect(131,294,150,12);
	    f.setColor(new Color(0,0,0));
	    f.drawString(mouseover,131,304);  	
	}
	
	public void update(Graphics f) {
	//super.update(f);
	
	f.drawString("CurTile = ",31,304);
	f.drawImage(cur_map.getTileset().getTileContents(Buffer.getCurTile()),83,294,95,306,0,0,23,23,new Color(0),this);	
	
	f.drawImage(button1, 7, 87, this); 
	f.drawImage(button2, 7, 112, this); 
	f.drawImage(button3, 7, 137, this);	
	
	//drawing tileset
	f.setColor(new Color(0,0,0));
	f.fillRect(401, 46, 100, 250); 
    for(int i=start*4;i<(start*4+40);i++) {
       	f.drawImage(cur_map.getTileset().getTileContents(i),401+((i%4)*25),46+((i/4)*25)-(start*25),this); 
    	} 		
	}
	
	/*Updates the current tile only!*/
	public void updateCurTile(Graphics f) {
		f.drawImage(cur_map.getTileset().getTileContents(Buffer.getCurTile()),83,294,95,306,0,0,23,23,new Color(0),this);	
	}
	
	/*Updates the layer tabs only!*/
	public void updateCurLayer(Graphics f) {
		f.drawImage(button1, 7, 87, this); 
		f.drawImage(button2, 7, 112, this); 
		f.drawImage(button3, 7, 137, this);	
	
	/*Mouseover part*/
	f.setColor(new Color(208,236,124));
	f.fillRect(131,294,150,12);
	f.setColor(new Color(0,0,0));
	f.drawString(mouseover,131,304);	
	}

    public void actionPerformed(ActionEvent e) {
        
		//Tile animation
        anim_iterator++;
        if(anim_iterator>=anim_delay) {
        	anim_iterator = 0;
        	Buffer.getCurMap().updateMap();
            }           
   
        //Map repaint       
       	screen.repaint();
    } 
    
    //Map Scrolling speed!
    private int scrollspeed = 6;
    
	public void keyPressed(KeyEvent e) {
		//Key controls
		int key = e.getKeyCode();
		
		//The arrow keys are used to scroll the map.
		if(key == e.VK_UP) {
			if(y>(scrollspeed-1)) y -= scrollspeed;
			screen.Update(x,y);
			}
		if(key == e.VK_DOWN) {
			if(y < (Buffer.getCurMap().getHeight())*24-(239 + scrollspeed)) y += scrollspeed;
			screen.Update(x,y);
			}	
		if(key == e.VK_LEFT) {
			if(x>(scrollspeed-1)) x -= scrollspeed;
			screen.Update(x,y);
			}	
		if(key == e.VK_RIGHT) {
			if(x < (Buffer.getCurMap().getWidth())*24-(359 + scrollspeed)) x += scrollspeed;
			screen.Update(x,y);
			}	
			
		//Keys 1,2 and 3 are used to switch layers.	
		if(key == e.VK_1) 
			{ 
			Buffer.setCurLayer(0); 
			button1 = b1B;
			button2 = b2A;
			button3 = b3A;
			this.updateCurLayer(this.getGraphics());
			}				
		if(key == e.VK_2) 
			{ 
			Buffer.setCurLayer(1); 
			button1 = b1A;
			button2 = b2B;
			button3 = b3A;
			this.updateCurLayer(this.getGraphics());
			}
		if(key == e.VK_3) 
			{ 
			Buffer.setCurLayer(2); 
			button1 = b1A;
			button2 = b2A;
			button3 = b3B;
			this.updateCurLayer(this.getGraphics());
			}
		
		if(key == e.VK_S) //Key S invokes the save dialogue
			{ 
			//Saving in SMF1 format
			FileIO.SaveObject(Lib_Util.WalkMap2SMF_WalkMap1(Buffer.getCurMap()), this);
			}
		if(key == e.VK_L) //Key L invokes the load dialogue
			{ 
			this.stopAnimation(); 
			//Loading in SMF1 format 
			Buffer.setCurMap(Lib_Util.SMF_WalkMap12WalkMap((SMF_WalkMap1) FileIO.LoadObject(this)));
			Buffer.initializeTiles(Buffer.getCurMap()); 
			this.cur_map = Buffer.getCurMap();
			screen.Update(x,y);
			this.paint(this.getGraphics());
			this.startAnimation();
			}
		
		if(key == e.VK_F5) //Key F5 invokes a very simple refresh :)
			{
			this.paint(this.getGraphics());	
			}	
		if(key == e.VK_SHIFT)
			{
			scrollspeed = 12;	
			}	
	}
	
	public void keyTyped(KeyEvent e) { }
	public void keyReleased(KeyEvent e) { 
		//Key controls
		int key = e.getKeyCode();
		if(key == e.VK_SHIFT)
			{
			scrollspeed = 6;	
			}	
	}
		
	public void mousePressed(MouseEvent e) {
		
		int mx = e.getX();
		int my = e.getY();	
		int tile_len = cur_map.getTileset().getLength();
		

    		
    	/*TILE PICKER*/	
    	if(mx>400&&mx<501&&my>45&&my<296) {
    		int selected = ((e.getX()-400)/25) + (((e.getY()-45)/25)*4) + (this.start*4);
    		if(selected < tile_len) { Buffer.setCurTile(selected); }    		
    		this.updateCurTile(this.getGraphics());
    	}
    	
    	/*MAP PANEL*/
    	  int cur_tile = Buffer.getCurTile();
    	  int x = (mx+this.x)/24; 
    	  int y = (my+this.y)/24;
    	  if(e.getSource() == screen && mx<360 && my<240) {    	
    		Buffer.getCurMap().setBlock(x,y,Buffer.getCurLayer(),cur_tile);
    		}  
    		
		/*BUTTON PANEL*/
		/*Resize Map*/
		if(mx>35&&mx<60&&my>351&&my<376) {
			ResizeDialog R = new ResizeDialog(this, "Resize Map:");
		}
		/*Save Map as...*/
		if(mx>35&&mx<60&&my>323&&my<348) {
			this.stopAnimation(); 
			//Saving in SMF1 format
			FileIO.SaveObject(Lib_Util.WalkMap2SMF_WalkMap1(Buffer.getCurMap()), this); 
			this.startAnimation();
		}
		/*Load Map*/
		if(mx>63&&mx<88&&my>351&&my<376) {		
			this.stopAnimation();
			//Loading in SMF1 format 
			Buffer.setCurMap(Lib_Util.SMF_WalkMap12WalkMap((SMF_WalkMap1) FileIO.LoadObject(this)));
			Buffer.initializeTiles(Buffer.getCurMap()); 
			this.cur_map = Buffer.getCurMap();
			screen.Update(x,y);
			this.paint(this.getGraphics());
			this.startAnimation();
		}
		/*Tile Editor*/
		if(mx>63&&mx<88&&my>323&&my<348) {
			TileDialog dia = new TileDialog(this, "Tile Properties", Buffer.getCurTile()); 
			this.update(this.getGraphics());
		}	
		/*New Map*/
		if(mx>91&&mx<116&&my>323&&my<348) {
			this.stopAnimation(); 
			Buffer.setCurMap((WalkMap) new WalkMap(new Tileset(),25,25));
			Buffer.initializeTiles(Buffer.getCurMap());
			this.cur_map = Buffer.getCurMap();
			screen.Update(x,y); 
			this.paint(this.getGraphics());
			this.startAnimation();
		}	
		
		/*Map to PNG export*/
		if(mx>91&&mx<116&&my>351&&my<376) {
			FileIO.RenderToImage(0);
			FileIO.RenderToImage(1);
			FileIO.RenderToImage(2);
			FileIO.RenderToImage(3);
		}
		
		/*TILE SCROLL ARROWS*/
		//g.drawImage(uparrow,502,45,this);
       	//g.drawImage(downarrow,502,289,this);
       	//size = 7 x 6
       	
       	if(mx>502&&mx<510&&my>45&&my<52) {
       		if(this.start>0) { this.start--; }
    		this.update(this.getGraphics());
       	}	
       	
		if(mx>502&&mx<510&&my>289&&my<296) {
			if(this.start<(cur_map.getTileset().getLength()/4)-10) { this.start++; }
    		this.update(this.getGraphics());
		}	
    }

    public void mouseReleased(MouseEvent e) {    }

    public void mouseEntered(MouseEvent e) {    }

    public void mouseExited(MouseEvent e) {    }

    public void mouseClicked(MouseEvent e) {    }
    
    public void mouseDragged(MouseEvent e) {	
    	//changes tile value whenever dragged and clicked.
    	int mx = e.getX();
    	int my = e.getY();
    	int cur_tile = Buffer.getCurTile();
    	int x = (mx+this.x)/24; 
    	int y = (my+this.y)/24;
    	if(e.getSource() == screen && mx>0 && my>0 && mx<360 && my<240) {    	
    		Buffer.getCurMap().setBlock(x,y,Buffer.getCurLayer(),cur_tile);
    		}    	
    	}

 	public void mouseMoved(MouseEvent e)  
 	{	
 	  if(e.getSource() == this) {
	    /*Mouseover part*/
	    int mx = e.getX();
	    int my = e.getY();
	    int changed = 0;
	    	    
	    if(mx>400&&mx<501&&my>45&&my<296) {
	  	  if(this.mouseover != "Tile Picker") {
	  	    this.mouseover = "Tile Picker";
	  	    changed = 1;
	  	  }  
	    }	
	    else if(mx>35&&mx<60&&my>351&&my<376) {
	      if(this.mouseover != "Resize Map") {	
	        this.mouseover = "Resize Map";
	        changed = 1;	
	      }
	    }	
	    else if(mx>35&&mx<60&&my>323&&my<348) {
	      if(this.mouseover != "Save Map As...") {  
	        this.mouseover = "Save Map As...";
	        changed = 1;
	      }
	    }	
	    else if(mx>63&&mx<88&&my>351&&my<376) {
	      if(this.mouseover != "Load Map") {	
	        this.mouseover = "Load Map";	
	        changed = 1;
	      }
	    }	
	    else if(mx>91&&mx<116&&my>323&&my<348) {
	      if(this.mouseover != "New Map") {	
	        this.mouseover = "New Map";	
	        changed = 1;
	      }  
	    }	
	    else if(mx>63&&mx<88&&my>323&&my<348) {
	      if(this.mouseover != "Tile Editor") {	
	        this.mouseover = "Tile Editor";
	        changed = 1;
	      }  
	    }
        else if(mx>6&&mx<21&&my>86&&my<107) {
          if(this.mouseover != "Layer 1") {	
            this.mouseover = "Layer 1";
            changed = 1;
          }
        }
        else if(mx>6&&mx<21&&my>111&&my<132) {
          if(this.mouseover != "Layer 2") {
            this.mouseover = "Layer 2";
            changed = 1;
          }
        }
        else if(mx>6&&mx<21&&my>136&&my<147) {
          if(this.mouseover != "Layer 3") {	
            this.mouseover = "Layer 3";
            changed = 1;
          }
        }    
        else if(mx>91&&mx<116&&my>351&&my<376) {
          if(this.mouseover != "Export to PNG") {	
            this.mouseover = "Export to PNG";
            changed = 1;
          }	  
        }    
	    else {
	      if(this.mouseover != "") {	
	        this.mouseover = "";	
	        changed = 1;
	      }  
	    }
	    if(changed == 1) {
	      changed = 0;
	      Graphics f = this.getGraphics();
	      /*Redrawing the string*/
    	  f.setColor(new Color(208,236,124));
	      f.fillRect(131,294,150,12);
	      f.setColor(new Color(0,0,0));
	      f.drawString(mouseover,131,304);
 	    }
 	  } 
 	}
 	
 	public void Refocus()
 	{
 		prompt.requestFocus();
 	}
 	
	public void windowGainedFocus(WindowEvent e) 
	{ 
	timer.start();				
	}
  	
  	public void windowLostFocus(WindowEvent e) { timer.stop(); } 
}	